@use "@/theme/base.scss";

.groupScenes {
  grid-area: content;
  width: 100%;
  height: 100%;
}

.groupGrid {
  width: 100%;
  height: 100%;
  padding: 1em;
  grid-area: groups;
  display: grid;
  grid-gap: 2rem;
  justify-content: center;
  align-content: center;
  justify-items: center;
  align-items: center;
  grid: auto-flow 1fr / 640px 640px;
}

.groupTable {
  background: url("../../resources/contentbg.png") !important;
  box-shadow: var(--box-shadow);
  border-radius: var(--border-radius);
  overflow: hidden;
  border: 0;
  > tbody {
    border: 3px solid var(--border-color) !important;
  }
  td {
    overflow: hidden;
    text-overflow: ellipsis;
  }
}

.groupSignupTitle {
  font-weight: bold;
  background: var(--dark-content-bg);
  text-align: center !important;
  border-bottom: 3px solid var(--border-color) !important;
}

.groupHighSignup,
.groupLowSignup {
  width: 50%;
  max-width: 0;
  border-left: 2px dashed var(--dark-content-bg) !important;
  border-right: 2px dashed var(--dark-content-bg) !important;
  overflow: hidden;
  // mutant the chicken master
  :global(.player-name) {
    white-space: pre;
  }
}

.groupHighScore {
  border-right: 3px solid var(--border-color) !important;
}

.groupHighSignup {
  text-align: right !important;
}

.groupLowScore,
.groupHighScore {
  min-width: 2rem;
  text-align: center;
  font-family: var(--font-family-mono);
}

.groupHighSignup,
.groupLowScore,
.groupHighScore,
.groupLowSignup {
  border-bottom: 2px dashed var(--dark-content-bg) !important;
  &[data-winner="true"] {
    background: var(--win-bg);
  }
}

//////////////////////
// Elim bracket styles
//////////////////////

$family-monospace: var(--mono-font-family);
$code: var(--bright);
$match-background: var(--background-color);
$match-background-winner: var(--primary-focus);
$body-color: var(--color);
$border: var(--box-border-color);
$border-hover: var(--bright);

.elimWrapper {
  display: flex;
  flex-direction: row;
  justify-content: center;
  align-items: center;
}

svg.elimBracketSvg {
  align-self: center;
  justify-self: center;
  shape-rendering: geometricPrecision;
  transform: scale(var(--zoom-scale)) translate(var(--zoom-x), var(--zoom-y));
  max-width: var(--viewbox-width);
  max-height: var(--viewbox-height);
  margin-bottom: -25px;
  --font-size: 22px;
}

.buttons {
  position: absolute;
  bottom: var(--spacing); // there is margin on the buttons
  right: var(--spacing);
  display: grid;
  grid: "in out";
  gap: var(--spacing);
}

.elimMatchId {
  font: calc(0.7 * var(--font-size)) var(--font-family-mono);
  z-index: 40;
  stroke: none;
  fill: $code;
  color: $code;
  filter: drop-shadow(0 2px 0 rgba(0, 0, 0, 0.33)) drop-shadow(0 2px 3px rgba(0, 0, 0, 0.2));
}

rect.elimMatchRect {
  fill: $match-background;
}

.elimMatchRow {
  &[data-winner="false"] {
    .elimSignup {
      opacity: 0.66;
    }
  }
  &[data-winner="true"] {
    font-weight: bold;
  }
}

.elimWinnerBg {
  fill: $match-background-winner;
}

g.elimRoundLabels {
  fill: var(--bright);
  font: calc(0.7 * var(--font-size)) var(--font-family);
  font-weight: bold;
  z-index: 40;
  dominant-baseline: hanging;
  text-anchor: middle;
}

@keyframes dropAnimate {
  to {
    stroke-dashoffset: -1000;
  }
}

g.elimDropPaths {
  stroke: $border;
  stroke-width: 1;
  stroke-linejoin: round;
  stroke-opacity: 1;
  stroke-dasharray: 4 4;
  stroke-dashoffset: 0;
  fill: none;
  filter: drop-shadow(0 2px 0 rgba(0, 0, 0, 0.33)) drop-shadow(0 2px 3px rgba(0, 0, 0, 0.2));
  z-index: 0;
  > path[data-highlight="true"] {
    stroke: $border-hover;
    stroke-width: 2;
    animation: dropAnimate 50s linear infinite;
  }
}

g.elimMatchPaths {
  stroke: $border;
  stroke-width: 2;
  stroke-linejoin: round;
  stroke-opacity: 1;
  fill: none;
  filter: drop-shadow(0 2px 0 rgba(0, 0, 0, 0.5)) drop-shadow(0 2px 3px rgba(0, 0, 0, 0.2));
}

g.elimMatches {
  // stroke: $background;
  // fill: $background;
  filter: url(#shadow);
  stroke-width: 4;
  z-index: 1;
  stroke-linejoin: round;
  stroke-opacity: 1;
}

g.elimMatchGroup {
  &[data-highlight="true"] {
    cursor: pointer;
  }
}

rect.elimMatchOutlineRect {
  transition: ease 0.1s stroke, stroke-width;
  stroke-width: 1;
  stroke: var(--background-color);
  fill: none;

  g.elimMatchGroup[data-scored="true"] > & {
    stroke: black;
    stroke-width: 2;
  }

  g.elimMatchGroup[data-pending="true"] > & {
    stroke: $border-hover;
    stroke-width: 2;
    stroke-dasharray: 4 4;
    stroke-dashoffset: 0;
    animation: dropAnimate 50s linear infinite;
  }

  g.elimMatchGroup[data-highlight="true"] > & {
    stroke: $border-hover;
    stroke-width: 2;
  }
}

.elimSignup {
  fill: var(--primary);
  dominant-baseline: middle;
  text-anchor: start;
  font-size: var(--font-size);
  &:hover {
    fill: var(--primary-hover);
  }
}

text.elimScore {
  font: calc(0.9 * var(--font-size)) var(--font-family-mono);
  text-anchor: end;
  dominant-baseline: middle;
  &[data-winner-loss="true"] {
    opacity: 0.66;
  }
  &[data-loser-win="false"] {
    opacity: 0.66;
  }
}

g.elimMatchContent {
  stroke: none;
  fill: $body-color;
}
